/* Эпизодическая память последовательности привлечения внимания - по каждому акту ориент.рефлекса
Линейная, не ветсящаяся цепочка структур.
Запоминается в файле episod_memory.txt для каждого периода бодрствоввания (до обнуления operMemory)
т.е. это - самая многочисленная часть памяти,
? НО будут запоминаться только ВАЖНЫЕ эпизоды или последние 10000 эпизодов ?
?? а как же тогда EpisodeID[] int в Experience struct?... Сделать лимит как можно больше.
Т.к. в EpisodeMemory используется ID автоматизма Automatism,
то эпизодическая память невозможна на рефлекторном уровне.

*/

package psychic

///////////////////////////////////////
type EpisodeMemory struct {
	ID int

	PulsCount int

	/* т.к. объекты хранятся до Сна, то после образотки инфа должна перейти
	в другие структуры (предположительные автоматизмы) а указатель окажется пустым.
	 */
	InfoEnv *InformationEnvironment

	Mood int // Настроение PsyMood

	NodeID[] int // узлы активных веток Дерева в последовательности их активации

	AutomatizmID int //автоматизм последнего узла

	TaskID int // мотивирующая цель, передаваемая при создании эпизода?

	Type int // объективный образ или субъективный:
	/*0 - такого нет в эпизодах, но при поиске по .Type==0 означает - любой тип памяти
	  1 - узел активировался с Пульта,
	  2 - Бот выдал на Пульт,
	  3 - Бот произвольно активировал
	  4 - был создан при воспоминании старого эпизода
	  5 - осмысление в func OwnBehaviour()
	*/

}
///////////////////////////////////////
// Эпизодическая память добавляется подряд как простой массив
var EpisodeMemoryObjects []*EpisodeMemory

/* ???
// эпизоды, для которых есть мот.автоматизм, индекс массива - EpisodeMemory.ID а значеие AutomatizmID
//т.е. в эпизоде PsyMemoryFromID[i].ID EpizodsWihtAutomatizmID[PsyMemoryFromID[i].ID] есть MotAutomatizm.ID
var EpizodsWihtAutomatizmID=make(map[int]int)

// эпизоды, в которых есть действие автоматизма Dnn: int, индекс массива - действие автоматизма Dnn: в виде строки
var EpizodsWihtAutomatizmD=make(map[string]*EpisodeMemory)
// эпизоды, в которых есть действие автоматизма Snn: string, индекс массива - действие автоматизма Snn: в виде строки
var EpizodsWihtAutomatizmS=make(map[string]*EpisodeMemory)
*/

/*текущий активный образ эпизодической памяти
 */
var EpisodeMemoryActiveFrame *EpisodeMemory

// Предыдущий фрагмент эпиз.памяти -  PsyMemoryFromID[EpisodeMemoryActiveFrame.ID-1]

/* чтобы получить список всех условий ветки дерева, начиная от данного узла к более общим узлам
condList:=GetBranchConditionList(&PsyMemory[231].TnodeID)
*/
///////////////////////////////////////////////////////




//////////////////////////////////////////
// запись эпизодической памяти
func saveEpisodicMenory(){
	var em EpisodeMemory
	EpisodeMemoryObjects=append(EpisodeMemoryObjects,&em)


}
///////////////////////////////////////////